const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const forum_threads = sequelize.define(
    'forum_threads',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

thread_title: {
        type: DataTypes.TEXT,
      
      

      },

thread_body: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"open",


"locked",


"removed"

        ],

      },

created_on: {
        type: DataTypes.DATE,
      
      

      },

last_activity_at: {
        type: DataTypes.DATE,
      
      

      },

upvotes_count: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  forum_threads.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























    db.forum_threads.hasMany(db.forum_posts, {
      as: 'forum_posts_thread',
      foreignKey: {
          name: 'threadId',
      },
      constraints: false,
    });
















//end loop



    db.forum_threads.belongsTo(db.forum_spaces, {
      as: 'space',
      foreignKey: {
        name: 'spaceId',
      },
      constraints: false,
    });

    db.forum_threads.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.forum_threads.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.forum_threads.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.forum_threads.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return forum_threads;
};


